
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Crm_stagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const crm_stages = await db.crm_stages.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_won: data.is_won
        ||
        false
        
            ,
            
        is_lost: data.is_lost
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await crm_stages.setCompany( data.company || null, {
            transaction,
        });
        
        await crm_stages.setPipeline( data.pipeline || null, {
            transaction,
        });
        

        

        

        return crm_stages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const crm_stagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_won: item.is_won
            ||
            false
        
            ,
            
                is_lost: item.is_lost
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const crm_stages = await db.crm_stages.bulkCreate(crm_stagesData, { transaction });

        // For each item created, replace relation files
        

        return crm_stages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const crm_stages = await db.crm_stages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_won !== undefined) updatePayload.is_won = data.is_won;
        
        
        if (data.is_lost !== undefined) updatePayload.is_lost = data.is_lost;
        
        
        updatePayload.updatedById = currentUser.id;

        await crm_stages.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await crm_stages.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.pipeline !== undefined) {
            await crm_stages.setPipeline(
              
              data.pipeline,
              
              { transaction }
            );
        }
        

        
        

        

        return crm_stages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const crm_stages = await db.crm_stages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of crm_stages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of crm_stages) {
                await record.destroy({transaction});
            }
        });


        return crm_stages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const crm_stages = await db.crm_stages.findByPk(id, options);

        await crm_stages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await crm_stages.destroy({
            transaction
        });

        return crm_stages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const crm_stages = await db.crm_stages.findOne(
            { where },
            { transaction },
        );

        if (!crm_stages) {
            return crm_stages;
        }

        const output = crm_stages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.leads_stage = await crm_stages.getLeads_stage({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.company = await crm_stages.getCompany({
            transaction
        });
        
        
        output.pipeline = await crm_stages.getPipeline({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userCompanies = (user && user.companies?.id) || null;
        

        
        if (userCompanies) {
            if (options?.currentUser?.companiesId) {
                where.companiesId = options.currentUser.companiesId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
      },

      {
        model: db.crm_pipelines,
        as: 'pipeline',
        
        where: filter.pipeline ? {
          [Op.or]: [
            { id: { [Op.in]: filter.pipeline.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.pipeline.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'crm_stages',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_won) {
                where = {
                    ...where,
                is_won: filter.is_won,
            };
            }
            
            if (filter.is_lost) {
                where = {
                    ...where,
                is_lost: filter.is_lost,
            };
            }
            


      
      if (filter.company) {
        const listItems = filter.company.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          companyId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.companiesId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.crm_stages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'crm_stages',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.crm_stages.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

